package xyz.brassgoggledcoders.boilerplate.lib.common.items;

import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import xyz.brassgoggledcoders.boilerplate.lib.common.registries.ItemRegistry;

import java.security.InvalidParameterException;
import java.util.List;

public class ItemSubBase extends ItemBase
{
	protected List<String> metaNames;

	public ItemSubBase(String name, List<String> metaNames)
	{
		this(name, "", metaNames);
	}

	public ItemSubBase(String name, String textureBase, List<String> metaNames)
	{
		super(name, textureBase);
		this.metaNames = metaNames;
		func_77656_e(metaNames.size());
		func_77627_a(true);
	}

	@Override
	public String func_77667_c(ItemStack itemStack)
	{
		int meta = itemStack.func_77952_i();
		if(meta < 0 || meta >= getMaxMeta())
		{
			meta = 0;
		}

		return super.func_77658_a() + "." + metaNames.get(meta);
	}

	@Override
	public void func_150895_a(Item item, CreativeTabs creativeTabs, List<ItemStack> list)
	{
		for(int meta = 0; meta < getMaxMeta(); ++meta)
		{
			list.add(new ItemStack(item, 1, meta));
		}
	}

	public int getMetaFromName(String name)
	{
		if(metaNames.contains(name))
		{
			return metaNames.indexOf(name);
		}
		return 0;
	}

	public String getNameFromMeta(int meta)
	{
		return metaNames.get(meta);
	}

	public int getMaxMeta()
	{
		return metaNames.size();
	}

	public ItemStack getStackByName(String name, int count)
	{
		if(metaNames.contains(name))
		{
			return new ItemStack(ItemRegistry.getItem(this.func_77658_a()), count, metaNames.indexOf(name));
		}
		throw new InvalidParameterException(name + " could not be found.");
	}

	public ItemStack getStackByName(String name)
	{
		return getStackByName(name, 1);
	}

	@Override
	public String[] getResourceLocations()
	{
		String[] locations = new String[getMaxMeta()];
		for(int i = 0; i < getMaxMeta(); i++)
		{
			locations[i] = texturePath + metaNames.get(i) + "_" + name;
		}
		return locations;
	}
}
